Index: java/main/src/main/java/com/framsticks/structure/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/TreeOperations.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/TreeOperations.java	(revision 105)
@@ -0,0 +1,386 @@
+package com.framsticks.structure;
+
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+import javax.annotation.Nonnull;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.File;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.Param;
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.PropertiesAccess;
+import com.framsticks.params.UniqueListAccess;
+import com.framsticks.params.ParamsUtil;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.parsers.Loaders;
+import com.framsticks.parsers.MultiParamLoader;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.RunAt;
+
+import static com.framsticks.params.ParamsUtil.getParam;
+
+import static com.framsticks.util.dispatching.Dispatching.*;
+
+public final class TreeOperations {
+
+	private static final Logger log = LogManager.getLogger(TreeOperations.class);
+
+	private TreeOperations() {
+	}
+
+	public static final SideNoteKey<Boolean> FETCHED_MARK = SideNoteKey.make(Boolean.class);
+
+	public static @Nonnull FramsClass processFetchedInfo(Tree tree, File file) {
+		assert tree.isActive();
+		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
+		log.debug("process fetched info for {}: {}", tree, framsClass);
+		tree.putInfoIntoCache(framsClass);
+		return framsClass;
+	}
+
+	public static Path create(Path path) {
+		assert !path.isResolved();
+
+		Access access = path.getTree().prepareAccess(path.getTop().getParam());
+		Object child = createAccessee(path.getTree(), access);
+		assert child != null;
+		if (path.size() == 1) {
+			path.getTree().assignRootObject(child);
+		} else {
+			Access parentAccess = bindAccess(path.getUnder());
+
+			/** this special case is not very good - maybe hide it in createAccessee? */
+			if (parentAccess instanceof UniqueListAccess) {
+				access.select(child);
+				access.set(((UniqueListAccess) parentAccess).getUidName(), path.getTop().getParam().getId());
+			}
+
+			parentAccess.set(path.getTop().getParam(), child);
+		}
+		path = path.appendResolution(child);
+		return path;
+	}
+
+	public static void processFetchedValues(final Path path, final List<File> files, final Access access, final FutureHandler<Path> future) {
+		assert files.size() == 1;
+		assert path.isTheSame(files.get(0).getPath());
+
+		try {
+			log.debug("process fetched values: {}", path);
+			final Access parsingAccess = new PropertiesAccess(access.getFramsClass());
+			final List<Object> results = MultiParamLoader.loadAll(files.get(0).getContent(), parsingAccess);
+
+			Dispatching.dispatchIfNotActive(path.getTree(), new RunAt<Tree>(future) {
+				@Override
+				protected void runAt() {
+
+					Path result = path.tryResolveIfNeeded();
+
+					if (!result.isResolved()) {
+						result = create(result);
+					}
+
+					if (path.getTop().getParam() instanceof ObjectParam) {
+						assert results.size() == 1;
+						ParamsUtil.takeAllNonNullValues(bindAccess(result), parsingAccess.select(results.get(0)));
+						mark(result.getTree(), result.getTopObject(), FETCHED_MARK, true);
+						future.pass(result);
+						return;
+					}
+
+					final ListAccess listAccess = (ListAccess) access;
+
+					listAccess.select(result.getTopObject());
+					Set<String> oldValuesIds = new HashSet<>();
+					for (Param p : listAccess.getParams()) {
+						oldValuesIds.add(p.getId());
+					}
+
+					Access targetAccess = listAccess.getElementAccess();//.cloneAccess();
+
+					int number = 0;
+					for (Object r : results) {
+
+						parsingAccess.select(r);
+						String id;
+						if (listAccess instanceof UniqueListAccess) {
+							id = parsingAccess.get(((UniqueListAccess) listAccess).getUidName(), String.class);
+						} else {
+							id = Integer.toString(number);
+						}
+						++number;
+
+						Object childTo = listAccess.get(id, Object.class);
+						boolean newOne;
+						if (childTo == null) {
+							childTo = createAccessee(result.getTree(), targetAccess);
+							newOne = true;
+						} else {
+							assert oldValuesIds.contains(id);
+							newOne = false;
+						}
+						oldValuesIds.remove(id);
+
+						targetAccess.select(childTo);
+						ParamsUtil.takeAllNonNullValues(targetAccess, parsingAccess);
+						if (newOne) {
+							listAccess.set(id, childTo);
+						}
+						mark(result.getTree(), childTo, FETCHED_MARK, true);
+
+					}
+					mark(result.getTree(), result.getTopObject(), FETCHED_MARK, true);
+
+					/** It looks tricky for ArrayListAccess but should also work.
+					 *
+					 * They should be sorted.
+					 */
+					for (String id : oldValuesIds) {
+						listAccess.set(id, null);
+					}
+					future.pass(result);
+				}
+			});
+
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("exception occurred while loading").cause(e);
+		}
+	}
+
+	public static FramsClass getInfo(Path path) {
+		Tree tree = path.getTree();
+		assert tree.isActive();
+		log.debug("get info for: {}", path);
+		final String name = path.getTop().getParam().getContainedTypeName();
+		return tree.getInfoFromCache(name);
+	}
+
+	public static void findInfo(final Path path, final FutureHandler<FramsClass> future) {
+		log.debug("find info for: {}", path);
+		try {
+			Tree tree = path.getTree();
+			assert tree.isActive();
+			final FramsClass framsClass = getInfo(path);
+			if (framsClass != null) {
+				future.pass(framsClass);
+				return;
+			}
+			tree.info(path, future);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	public static @Nonnull
+	Access bindAccessFromSideNote(Tree tree, Object object) {
+		CompositeParam param = tree.getSideNote(object, Path.OBJECT_PARAM_KEY);
+		if (param == null) {
+			throw new FramsticksException().msg("failed to bind access from side node").arg("tree", tree).arg("object", object).arg("type", object.getClass());
+		}
+		return tree.prepareAccess(param).select(object);
+	}
+
+	public static @Nonnull
+	Access bindAccess(Tree tree, String path) {
+		log.debug("bind access for textual: {} in {}", path, tree);
+		return bindAccess(Path.to(tree, path));
+	}
+
+	public static @Nonnull
+	Access bindAccess(Node node) {
+		Tree tree = node.getTree();
+		assert tree.isActive();
+		assert node.getObject() != null;
+
+		try {
+			Access access = tree.prepareAccess(node.getParam());
+			tree.putSideNote(node.getObject(), Path.OBJECT_PARAM_KEY, node.getParam());
+
+			return access.select(node.getObject());
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam()).cause(e);
+			// log.error("failed to bind access for {}: ", node.getParam(), e);
+		}
+	}
+
+	public static @Nonnull
+	Access bindAccess(Path path) {
+		assert path.getTree().isActive();
+		path.assureResolved();
+		log.debug("bind access for: {}", path);
+		return bindAccess(path.getTop());
+	}
+
+	public static void set(final Path path, final PrimitiveParam<?> param, final Object value, final FutureHandler<Integer> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.set(path, param, value, future);
+			}
+		});
+	}
+
+	public static <R> void call(final Path path, final String procedureName, final Object[] arguments, final Class<R> resultType, final FutureHandler<R> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				path.assureResolved();
+				tree.call(path, getParam(path, procedureName, ProcedureParam.class), arguments, resultType, future);
+			}
+		});
+	}
+
+	public static <R> void call(final Path path, final ProcedureParam param, final Object[] arguments, final Class<R> resultType, final FutureHandler<R> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.call(path, param, arguments, resultType, future);
+			}
+		});
+	}
+
+	public static <A> void addListener(final Path path, final EventParam param, final EventListener<A> listener, final Class<A> argument, final FutureHandler<Void> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.addListener(path, param, listener, argument, future);
+			}
+		});
+	}
+
+	public static void removeListener(final Path path, final EventParam param, final EventListener<?> listener, final FutureHandler<Void> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				tree.removeListener(path, param, listener, future);
+			}
+		});
+	}
+
+	/**
+	 *
+	 * If StackOverflow occurs in that loop in LocalTree it is probably caused
+	 * the by the fact, that get operation may find the object, but Path resolution
+	 * cannot.
+	 * */
+	public static void tryGet(final Tree tree, final String targetPath, final FutureHandler<Path> future) {
+		log.debug("resolve textual: {} for {}", targetPath, tree);
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+
+			@Override
+			protected void runAt() {
+				final Path path = Path.tryTo(tree, targetPath).tryResolveIfNeeded();
+				log.debug("found: {}", path);
+				if (path.isResolved()) {
+					future.pass(path);
+					return;
+				}
+
+				tree.get(path, new Future<Path>(future) {
+					@Override
+					protected void result(Path result) {
+						// if (result.isResolved(targetPath)) {
+						//	future.pass(result);
+						//	return;
+						// }
+						log.debug("retrying resolve textual: {} for {} with {}", targetPath, tree, result);
+						tryGet(tree, targetPath, future);
+					}
+				});
+			}
+		});
+	}
+
+	public static FramsClass getInfoFromCache(Path path) {
+		assert path.getTree().isActive();
+		return path.getTree().getInfoFromCache(path.getTop().getParam().getContainedTypeName());
+	}
+
+	public static Object createAccessee(Tree tree, CompositeParam param) {
+		Object object = tree.prepareAccess(param).createAccessee();
+		tree.putSideNote(object, Path.OBJECT_PARAM_KEY, param);
+		return object;
+	}
+
+	public static Object createAccessee(Tree tree, Access access) {
+		Object object = access.createAccessee();
+		tree.putSideNote(object, Path.OBJECT_PARAM_KEY, access.buildParam(new ParamBuilder()).finish(CompositeParam.class));
+		return object;
+	}
+
+	public static boolean isMarked(Tree tree, Object object, SideNoteKey<Boolean> mark, boolean defValue) {
+		assert tree.isActive();
+		Boolean v = tree.getSideNote(object, mark);
+		return (v != null ? v : defValue);
+	}
+
+	public static void mark(Tree tree, Object object, SideNoteKey<Boolean> mark, boolean value) {
+		assert tree.isActive();
+		tree.putSideNote(object, mark, value);
+	}
+
+	public static FramsClass getFramsClass(Path path) {
+		return path.getTree().getRegistry().getFramsClass(path.getTop().getParam());
+	}
+
+	// public static <T extends Param> T getParam(Path path, String id, Class<T> type) {
+	// 	return getFramsClass(path).getParamEntry(id, type);
+	// }
+
+	public static <T> T getOrCreateSideNote(Tree tree, Object object, SideNoteKey<T> key) {
+		T result = tree.getSideNote(object, key);
+		if (result == null) {
+			result = key.newValue();
+			tree.putSideNote(object, key, result);
+		}
+		return result;
+	}
+
+	public static <T> boolean hasSideNotes(Tree tree, Object object, SideNoteKey<T> key) {
+		return tree.getSideNote(object, key) != null;
+	}
+
+	public static <T> boolean hasSideNote(Path path, SideNoteKey<T> key) {
+		return path.getTree().getSideNote(path.getTopObject(), key) != null;
+	}
+
+	public static <T> T getSideNote(Path path, SideNoteKey<T> key) {
+		assert path.isResolved();
+		return path.getTree().getSideNote(path.getTopObject(), key);
+	}
+
+	public static <T> void putSideNote(Path path, SideNoteKey<T> key, T value) {
+		path.getTree().putSideNote(path.getTopObject(), key, value);
+	}
+
+	public static boolean removeSideNote(Path path, SideNoteKey<?> key) {
+		assert path.isResolved();
+		return path.getTree().removeSideNote(path.getTopObject(), key);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/test/PrimeExperiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 105)
@@ -8,5 +8,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ValueChange;
 import com.framsticks.experiment.Experiment;
 import com.framsticks.experiment.WorkPackageLogic;
@@ -15,8 +14,10 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.test.prime.ExpParams;
 import com.framsticks.test.prime.PrimePackage;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 
 @FramsClassAnnotation
@@ -33,5 +34,5 @@
 	protected int nextWaitNumber = 1;
 	protected List<PrimePackage> waitingPackages = new LinkedList<>();
-	protected List<Integer> primes = new LinkedList<>();
+	// protected List<Integer> primes = new LinkedList<>();
 
 	protected final EventListeners<ValueChange> primesListeners = new EventListeners<>();
@@ -50,5 +51,5 @@
 
 			@Override
-			protected void generateNextPackage(Future<PrimePackage> future) {
+			protected void generateNextPackage(FutureHandler<PrimePackage> future) {
 				assert isActive();
 				if (task.state.current_number > task.params.to_number) {
@@ -84,8 +85,12 @@
 					return;
 				}
-				log.info("experiment is done, {} primes found", primes.size());
-				log.debug("primes: {}", primes);
+				log.info("experiment is done, {} primes found", getPrimes().size());
+				log.debug("primes: {}", getPrimes());
 			}
 		};
+	}
+
+	public List<Integer> getPrimes() {
+		return task.state.getResultList();
 	}
 
@@ -98,5 +103,5 @@
 		}
 
-		primes.addAll(result.state.getResultList());
+		getPrimes().addAll(result.state.getResultList());
 		nextWaitNumber = result.params.to_number + 1;
 
@@ -141,5 +146,5 @@
 	@ParamAnnotation
 	public String getDescription() {
-		return primes.size() + " found in range " + new ExpParams(task.params.from_number, nextWaitNumber - 1);
+		return getPrimes().size() + " found in range " + new ExpParams(task.params.from_number, nextWaitNumber - 1);
 	}
 
@@ -154,3 +159,8 @@
 	}
 
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public PrimePackage experimentNetsave() {
+		return task;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/test/TestClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 105)
@@ -6,6 +6,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ListChange;
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.SimplePrimitive;
@@ -15,4 +13,6 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.ValueChange;
 
 @FramsClassAnnotation(
@@ -135,3 +135,4 @@
 	}
 
+
 }
Index: java/main/src/main/java/com/framsticks/test/TestSerializedClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestSerializedClass.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/test/TestSerializedClass.java	(revision 105)
@@ -0,0 +1,26 @@
+package com.framsticks.test;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.UniversalParam;
+
+@FramsClassAnnotation(order = {"theArray"})
+public class TestSerializedClass {
+
+	protected List<Object> theArray = new ArrayList<>();
+
+	@ParamAnnotation(paramType = UniversalParam.class)
+	public List<Object> getTheArray() {
+		return theArray;
+	}
+
+	@ParamAnnotation(paramType = UniversalParam.class)
+	public void setTheArray(List<Object> theArray) {
+		this.theArray = theArray;
+	}
+
+		// assertThat(framsClass.getParam("theArray")).isInstanceOf(UniversalParam.class);
+}
Index: java/main/src/main/java/com/framsticks/test/prime/ExpState.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/prime/ExpState.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/test/prime/ExpState.java	(revision 105)
@@ -4,5 +4,5 @@
 import java.util.List;
 
-import org.apache.commons.lang.StringUtils;
+import org.apache.commons.lang3.StringUtils;
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
Index: java/main/src/main/java/com/framsticks/util/ExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/ExceptionHandler.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/util/ExceptionHandler.java	(revision 105)
@@ -0,0 +1,6 @@
+package com.framsticks.util;
+
+
+public interface ExceptionHandler {
+	public void handle(FramsticksException exception);
+}
Index: java/main/src/main/java/com/framsticks/util/FramsticksException.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/FramsticksException.java	(revision 105)
@@ -4,5 +4,4 @@
 import java.util.List;
 
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.lang.Delimeted;
 import com.framsticks.util.lang.Pair;
@@ -77,6 +76,6 @@
 
 
-	public static ExceptionResultHandler addArgumentHandler(final ExceptionResultHandler innerHandler, final String header, final Object argument) {
-		return new ExceptionResultHandler() {
+	public static ExceptionHandler addArgumentHandler(final ExceptionHandler innerHandler, final String header, final Object argument) {
+		return new ExceptionHandler() {
 			@Override
 			public void handle(FramsticksException exception) {
Index: java/main/src/main/java/com/framsticks/util/Logging.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Logging.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/Logging.java	(revision 105)
@@ -3,5 +3,4 @@
 import org.apache.logging.log4j.Logger;
 
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
@@ -20,6 +19,6 @@
 	}
 
-	public static ExceptionResultHandler logger(final Logger logger, final String action, final Object subject) {
-		return new ExceptionResultHandler() {
+	public static ExceptionHandler logger(final Logger logger, final String action, final Object subject) {
+		return new ExceptionHandler() {
 			@Override
 			public void handle(FramsticksException e) {
Index: java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 105)
@@ -92,6 +92,8 @@
 
 	public void createThreadIfNeeded() {
-		if (targetDispatcher != null) {
-			return;
+		synchronized (this) {
+			if (targetDispatcher != null) {
+				return;
+			}
 		}
 		this.setTargetDispatcher(new Thread<C>().setName(parent.getName()));
@@ -104,10 +106,10 @@
 
 	@Override
-	protected void joinableStart() {
+	protected synchronized void joinableStart() {
 		Dispatching.use(targetDispatcher, this);
 	}
 
 	@Override
-	protected void joinableInterrupt() {
+	protected synchronized void joinableInterrupt() {
 		Dispatching.drop(targetDispatcher, this);
 
@@ -121,5 +123,5 @@
 
 	@Override
-	protected void joinableJoin() throws InterruptedException {
+	protected synchronized void joinableJoin() throws InterruptedException {
 		Dispatching.join(targetDispatcher);
 	}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 105)
@@ -7,4 +7,5 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
@@ -141,15 +142,15 @@
 	}
 
-	public interface Query<T> extends ExceptionResultHandler {
+	public interface Query<T> extends ExceptionHandler {
 		T get();
 	}
 
 	public static abstract class QueryHandler<T> implements Query<T> {
-		ExceptionResultHandler handler;
+		ExceptionHandler handler;
 
 		/**
 		 * @param handler
 		 */
-		public QueryHandler(ExceptionResultHandler handler) {
+		public QueryHandler(ExceptionHandler handler) {
 			this.handler = handler;
 		}
@@ -244,10 +245,10 @@
 
 		protected final double timeOut;
-		protected final ExceptionResultHandler handler;
+		protected final ExceptionHandler handler;
 
 		/**
 		 * @param timeOut
 		 */
-		public Waiter(double timeOut, ExceptionResultHandler handler) {
+		public Waiter(double timeOut, ExceptionHandler handler) {
 			this.timeOut = timeOut;
 			this.handler = handler;
@@ -273,6 +274,6 @@
 		}
 
-		public <T> Future<T> passInFuture(Class<T> type) {
-			return new FutureHandler<T>(handler) {
+		public <T> FutureHandler<T> passInFuture(Class<T> type) {
+			return new Future<T>(handler) {
 				@Override
 				protected void result(T result) {
Index: java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/DispatchingExceptionHandler.java	(revision 105)
@@ -1,10 +1,11 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-public class DispatchingExceptionHandler implements ExceptionResultHandler {
+public class DispatchingExceptionHandler implements ExceptionHandler {
 
 	protected final Dispatcher<?> dispatcher;
-	protected final ExceptionResultHandler handler;
+	protected final ExceptionHandler handler;
 
 	/**
@@ -12,5 +13,5 @@
 	 * @param handler
 	 */
-	public DispatchingExceptionHandler(Dispatcher<?> dispatcher, ExceptionResultHandler handler) {
+	public DispatchingExceptionHandler(Dispatcher<?> dispatcher, ExceptionHandler handler) {
 		this.dispatcher = dispatcher;
 		this.handler = handler;
Index: java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/DispatchingFuture.java	(revision 105)
@@ -3,8 +3,8 @@
 import com.framsticks.util.FramsticksException;
 
-public class DispatchingFuture<C, T> extends Future<T> {
+public class DispatchingFuture<C, T> extends FutureHandler<T> {
 
 	protected final Dispatcher<? super C> dispatcher;
-	protected final Future<T> future;
+	protected final FutureHandler<T> future;
 
 	/**
@@ -12,5 +12,5 @@
 	 * @param future
 	 */
-	public DispatchingFuture(Dispatcher<? super C> dispatcher, Future<T> future) {
+	public DispatchingFuture(Dispatcher<? super C> dispatcher, FutureHandler<T> future) {
 		this.dispatcher = dispatcher;
 		this.future = future;
@@ -37,5 +37,5 @@
 	}
 
-	public static <Ca, Ta> Future<Ta> create(Dispatcher<Ca> dispatcher, Future<Ta> future) {
+	public static <Ca, Ta> FutureHandler<Ta> create(Dispatcher<Ca> dispatcher, FutureHandler<Ta> future) {
 		return new DispatchingFuture<Ca, Ta>(dispatcher, future);
 	}
Index: java/main/src/main/java/com/framsticks/util/dispatching/ExceptionDispatcherHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/ExceptionDispatcherHandler.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/util/dispatching/ExceptionDispatcherHandler.java	(revision 105)
@@ -0,0 +1,6 @@
+package com.framsticks.util.dispatching;
+
+public interface ExceptionDispatcherHandler {
+	public boolean handle(Dispatcher<?> dispatcher, Throwable throwable);
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Future.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Future.java	(revision 105)
@@ -1,21 +1,30 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-/**
- * @author Piotr Sniegowski
- */
-public abstract class Future<T> implements ExceptionResultHandler {
+public abstract class Future<T> extends FutureHandler<T> {
 
-	protected abstract void result(T result);
+	protected final ExceptionHandler handler;
 
-	public final void pass(T result) {
-		try {
-			result(result);
-		} catch (FramsticksException e) {
-			handle(e);
-		}
+	public Future(ExceptionHandler handler) {
+		assert handler != null;
+		this.handler = handler;
 	}
 
+	@Override
+	public final void handle(FramsticksException exception) {
+		handler.handle(exception);
+	}
+
+	public static <T> Future<T> doNothing(Class<T> type, ExceptionHandler handler) {
+		return new Future<T>(handler) {
+
+			@Override
+			protected void result(T result) {
+
+			}
+		};
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 105)
@@ -1,29 +1,20 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-public abstract class FutureHandler<T> extends Future<T> {
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class FutureHandler<T> implements ExceptionHandler {
 
-	protected final ExceptionResultHandler handler;
+	protected abstract void result(T result);
 
-	public FutureHandler(ExceptionResultHandler handler) {
-		assert handler != null;
-		this.handler = handler;
+	public final void pass(T result) {
+		try {
+			result(result);
+		} catch (FramsticksException e) {
+			handle(e);
+		}
 	}
-
-	@Override
-	public final void handle(FramsticksException exception) {
-		handler.handle(exception);
-	}
-
-	public static <T> FutureHandler<T> doNothing(Class<T> type, ExceptionResultHandler handler) {
-		return new FutureHandler<T>(handler) {
-
-			@Override
-			protected void result(T result) {
-
-			}
-		};
-	}
-
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java	(revision 105)
@@ -1,7 +1,8 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-public class IgnoreExceptionHandler implements ExceptionResultHandler {
+public class IgnoreExceptionHandler implements ExceptionHandler {
 
 	private static final IgnoreExceptionHandler instance = new IgnoreExceptionHandler();
Index: java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 105)
@@ -104,10 +104,10 @@
 	}
 
-	protected ExceptionHandler taskExceptionHandler;
+	protected ExceptionDispatcherHandler taskExceptionHandler;
 
 	/**
 	 * @return the taskExceptionHandler
 	 */
-	public ExceptionHandler getTaskExceptionHandler() {
+	public ExceptionDispatcherHandler getTaskExceptionHandler() {
 		return taskExceptionHandler;
 	}
@@ -116,5 +116,5 @@
 	 * @param taskExceptionHandler the taskExceptionHandler to set
 	 */
-	public void setTaskExceptionHandler(ExceptionHandler taskExceptionHandler) {
+	public void setTaskExceptionHandler(ExceptionDispatcherHandler taskExceptionHandler) {
 		this.taskExceptionHandler = taskExceptionHandler;
 	}
Index: java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 105)
@@ -1,11 +1,12 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-public abstract class RunAt<C> implements ExceptionResultHandler, Runnable {
+public abstract class RunAt<C> implements ExceptionHandler, Runnable {
 
-	protected final ExceptionResultHandler handler;
+	protected final ExceptionHandler handler;
 
-	public RunAt(ExceptionResultHandler handler) {
+	public RunAt(ExceptionHandler handler) {
 		assert handler != null;
 		this.handler = handler;
